<?php
// $Id: pe_admission.admin.inc,v 1.10 2010/02/24 06:06:54 dakala Exp $

/**
 * @file
 *
 */

function pe_admission_admin_settings() { 


  return system_settings_form($form);
}


function pe_admission_entry_mode() {
  global $user;

    $output = '';
    $output .= '<p>'. t('List of modes of entry into the university.') .'</p>';
    $output .= '<p>'. l(t('Add new entry'), 'admin/phpedu/admission/modes/edit') .'</p>';

    $header = array(
        array('data' => t('#')),
        array('data' => t('Mode (short)'), 'field' => 'mode_short', 'sort' => 'asc'),
        array('data' => t('Mode (long)'), 'field' => 'mode_long'),
        array('data' => t('Description'), 'field' => 'mode_description'),
        array('data' => t('Operation')),
    );

    $query = "SELECT mode_id, mode_short, mode_long, mode_description FROM {pe_entry_mode}";
    
    $tablesort = tablesort_sql($header);

    $result = db_query($query . $tablesort);

    $i = 0;
    while ($row = db_fetch_object($result)) {
      $rows[] = array(
          array('data' => $i + 1, 'align' => 'center'),
          array('data' => drupal_strtoupper($row->mode_short), 'align' => 'center'),
          array('data' => $row->mode_long),
          array('data' => $row->mode_description),
          array('data' => l(t('Edit'), 'admin/phpedu/admission/modes/edit/'. $row->mode_id)),
      );
      $i++;
    }

    $output .= theme('table', $header, $rows);

    return $output;
  
}



function pe_admission_modes_edit() {
  $mode_id = arg(5);
  $output = '';
  $instruction = ($mode_id > 0) ? t('Edit or delete the mode of entry details below.') : t('Add new mode of entry details.');
  $output .= '<p>'. $instruction .'</p>';
  $output .= drupal_get_form('pe_admission_modes_edit_form', $mode_id);
  return $output;
}



function pe_admission_modes_edit_form(&$form_state, $mode_id) {
  if ($mode_id > 0) {
    
    $mode = db_fetch_object(db_query("SELECT mode_id, mode_short, mode_long, mode_description FROM {pe_entry_mode} WHERE mode_id = %d", $mode_id));

    $form['mode_id'] = array(
        '#type' => 'value',
        '#value' => $mode_id,
    );
  }

  $form['mode_short'] = array(
      '#type' => 'textfield',
      '#title' => t('Mode (short)'),
      '#default_value' => drupal_strtoupper($mode->mode_short),
      '#description' => t('Short form or acronym of the mode of entry'),
      '#size' => 20,
  );

  $form['mode_long'] = array(
      '#type' => 'textfield',
      '#title' => t('Mode (long)'),
      '#default_value' => $mode->mode_long,
      '#description' => t('Enter the full name of the mode of entry'),
      '#size' => 60,
  );

  $form['mode_description'] = array(
    '#type' => 'textarea',
    '#title' => t('Description'),
    '#default_value' => $mode->mode_description,
    '#cols' => 60,
    '#rows' => 5,
    '#description' => t('Additional information about the mode of entry'),
  );


  $form['submit'] = array(
      '#type' => 'submit',
      '#value' => ($mode_id > 0) ? t('Edit') : t('Add'),
      '#prefix' => ($mode_id > 0) ? '<div class="container-inline">' : '',
  );

  if ($mode_id > 0) {
    $form['delete'] = array(
        '#type' => 'submit',
        '#value' => t('Delete'),
        '#suffix' => '</div>',
    );
  }
  
  return $form;
}




function pe_admission_modes_edit_form_submit($form, &$form_state) {
  $clicked = $form_state['clicked_button']['#post']['op'];
  if (drupal_strlen($clicked) > 0) {
    $edit = $form_state['values'];

    if((drupal_strlen($edit['mode_short']) < 1) || (drupal_strlen($edit['mode_long']) < 1)) {

      if (drupal_strlen($edit['mode_short']) < 1) {
        form_set_error('mode_short', t('Enter the short form for this mode of entry.'));
      }
      if (drupal_strlen($edit['mode_long']) < 1) {
        form_set_error('mode_long', t('Enter the full form for this mode of entry.'));
      }
    }
    else {
      switch ($clicked) {
        case t('Add'):
          db_query("INSERT INTO {pe_entry_mode} (mode_short, mode_long, mode_description) VALUES('%s', '%s', '%s')", $edit['mode_short'], $edit['mode_long'], $edit['mode_description']);
          $message = t('You have added a new mode of entry.');
          break;
        case t('Edit'):
          db_query("UPDATE {pe_entry_mode} SET mode_short = '%s', mode_long = '%s', mode_description = '%s' WHERE mode_id = %d", $edit['mode_short'], $edit['mode_long'], $edit['mode_description'], $edit['mode_id']);
          $message = t('You have edited a mode of entry.');
          break;
        case t('Delete'):
          db_query("DELETE FROM {pe_entry_mode} WHERE mode_id = %d", $edit['mode_id']);
          $message = t('You have deleted a mode of entry.');
          break;
      }
    }
    drupal_set_message($message);
    $url = 'admin/phpedu/admission/modes';
  }
  else {
    $url = 'admin/phpedu/admission/modes/edit';
  }
  drupal_goto($url);
}